package com.zt.plat.module.qms.common.data.service;

import java.util.*;

import com.zt.plat.framework.common.pojo.CommonResult;
import com.zt.plat.module.qms.common.data.controller.vo.*;
import com.zt.plat.module.qms.common.data.dal.dataobject.DataCollectionDO;
import com.zt.plat.module.qms.common.data.dal.dataobject.DataTemplateDO;
import jakarta.validation.*;
import com.zt.plat.framework.common.pojo.PageResult;

/**
 * 表单设计器模板 Service 接口
 *
 * @author 后台管理
 */
public interface DataTemplateService {

    DataTemplateDO getLatestDataByKey(String key);

    /*获取分类树数据*/
    List<DataTemplateDO> getTreeData();

    //保存数据集
    CommonResult<String> saveData(@Valid DataTemplateSaveReqVO createReqVO);
    CommonResult<String> saveDataWithNewVersion(@Valid DataTemplateSaveReqVO createReqVO);

    //保存分类
    CommonResult<DataTemplateRespVO> saveClassify(@Valid DataTemplateSaveReqVO createReqVO);

    //更新后代节点路径-递归调用
    CommonResult<String> updateAllIdPath(Long parentId, Integer level);

    List<DataTemplateDO> listByParId(Long parId);
    /**
     * 创建表单设计器模板
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    DataTemplateRespVO createDataTemplate(@Valid DataTemplateSaveReqVO createReqVO);

    /**
     * 更新表单设计器模板
     *
     * @param updateReqVO 更新信息
     */
    void updateDataTemplate(@Valid DataTemplateSaveReqVO updateReqVO);

    /**
     * 删除表单设计器模板
     *
     * @param id 编号
     */
    void deleteDataTemplate(Long id);

    /**
    * 批量删除表单设计器模板
    *
    * @param ids 编号
    */
    void deleteDataTemplateListByIds(List<Long> ids);

    /**
     * 获得表单设计器模板
     *
     * @param id 编号
     * @return 表单设计器模板
     */
    DataTemplateDO getDataTemplate(Long id);

    /**
     * 获得表单设计器模板分页
     *
     * @param pageReqVO 分页查询
     * @return 表单设计器模板分页
     */
    PageResult<DataTemplateDO> getDataTemplatePage(DataTemplatePageReqVO pageReqVO);

}